/*
** ConfigLib.h
**
** Modified by psl 03 08 99 
*/ 

#ifndef __CONFIG_LIB_H__
#define __CONFIG_LIB_H__
#include "Constants.h"
#include "DspLib.h"

typedef struct s_dsprc t_dsprc;
struct s_dsprc
{
  char     esd_client[MAX_LINE_LEN]; /* if the device is an esd client */
  int      bits_per_sample;     /* bits par sample */
  int      channels;            /* voies */
  int      sample_rate;         /* frquence d'chantillonage */
  char     name[MAX_NAME_SZ];   /* nom du fichier ("/dev/dsp" par exemple) */
  char     vendor[MAX_NAME_SZ]; /* Nom de la carte (Gravis Ultrasound par exemple) */
  t_dsp*   dsp;                 /* t_dsp* correspondant */
  t_dsprc* next_dsp;            /* dsp suivant dans la liste chane */
}; /* s_dsprc : conf d'un dsp */

typedef struct s_gmurfrc t_gmurfrc;
struct s_gmurfrc
{
  int      num_of_dsps;  /* Nombre de DSPs sur la machine */
  int      buffer_size;  /* Taille du buffer */
  char     temp_dir[50]; /* Repertoire temporaire */
  t_dsp*   first_dsp_in_list;
  t_dsprc* first_dsp;
}; /* s_gmurfrc : conf principale */

/*
** Functions
*/

t_gmurfrc* gmurfrc_defaults();	/* Ceee une conf par defaut */

t_gmurfrc* gmurfrc_read(	/* Lit une conf */
			char*	/* Nom du fichier  lire */
			);

int gmurfrc_write(	        /* Ecrit une conf  */
		  t_gmurfrc*,	/* Nom de la struct a sauvegarder */
		  char*         /* Nom du fichier  sauvegarder */
		  );

int gmurfrc_destroy(            /* Dtruit un gmurfrc */
		    t_gmurfrc*	/* Le gmurfrc  dtruire */
		    );

#endif








