/*
** Charge_Sound.c for Gmurf in ~/Gmurf/Charge_Sound/
** 
** Made by 
** Login   <ahes@ker-ys.epita.fr>
** 
** Started on  Fri Mar  5 19:03:30 1999 
** Last update Mon Mar 15 20:30:02 1999 Rmi Coupet
*/
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include "Errors.h"
#include <stdlib.h>
#include <unistd.h>
#include "Fct_Sys.h"
#include "DebugLib.h"
#include "WavePlay.h"
#include "Set_Rate.h"
#include "8bM_16bS.h"
#include <sys/wait.h>
#include "Swap_File.h"
#include "Constants.h"
#include "WaveHeader.h"
#include "Save_Sound.h"
#include "Parse_Saver_Conf.h"

/*
** exec_plug_in: execute the plug-in
*/
static	int	exec_plug_in(argv, plug_in_path, gmurf_rate, file_name)
char		*argv[3];
char		*plug_in_path;
int		gmurf_rate;
char		*file_name;
{
  char	*rate;

  rate = itoa(gmurf_rate);
  if (execlp(plug_in_path, plug_in_path, swap_file, rate, file_name, NULL) == -1)
  {
#ifdef TEXT_MSG
    printf("error during the execution of %s with %s\n", argv[0], file2save);
    printf("errno = %d\n", errno);
#endif
    exit(-1);
    return (1);
  }
return (-1);
}


/*
** save_sound_file: save a sound file
*/
int		*save_sound_file(tempgmurf, gmurf_rate, file_name)
t_tempgmurf	*tempgmurf;
int		gmurf_rate;
char		*file_name;
{
  int		child_status;
  char		*argv[3];
  char		*plug_in_path;
  PID_T		pid;

  if ((plug_in_path = get_sound_saver_path(tempgmurf->origname)) == NULL)
    return(NULL);
  if (make_swap_file((void *) tempgmurf, sizeof(t_tempgmurf)) == -1)
    return (NULL);
  if ((pid = fork()) == -1) 
    {
      gmurf_errno = BAD_FORK;
      return (NULL);
    }
  if (pid == 0)
    {
      if (exec_plug_in(argv, plug_in_path, gmurf_rate, file_name) == -1)
	{
	  print_gmurf_error("\0");
	  exit(-1);
	}
    }
  else        
    waitpid(pid, &child_status, WUNTRACED);
  return (0);
}
