#ifndef __WAVEDITOR_H__

#define __WAVEDITOR_H__

#include "gtk/gtk.h"
#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define BUTTONS			4
#define CHANNELS		2
#define IWIDTH			540
#define IHEIGHT			110

#define WAVEDITOR(obj)          GTK_CHECK_CAST (obj, \
						waveditor_get_type (), \
						Waveditor)
#define WAVEDITOR_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, \
						      waveditor_get_type (), \
						      WaveditorClass)   
#define IS_WAVEDITOR(obj)       GTK_CHECK_TYPE (obj, waveditor_get_type ())

#define EVENT_METHOD(j, x) GTK_WIDGET_CLASS (GTK_OBJECT (j)->klass)->x

typedef struct _Waveditor       Waveditor;
typedef struct _WaveditorClass  WaveditorClass;

struct		_Waveditor
{
  GtkVBox	vbox ;
  GtkWidget	*DrawingArea[CHANNELS] ;
  GdkPixmap	*pixmap[CHANNELS] ;
  gint		(*draw_wav_left)	(GtkWidget *widget, gpointer data) ;
  gint		(*draw_wav_right)	(GtkWidget *widget, gpointer data) ;
  struct	selmem
  {
    size_t	x ;
    size_t 	y ;
  }		selection, part_watched;
  GtkWidget	*hscrollbar ;
  GtkWidget	*SU_label ;
  GtkWidget	*Sec_label ;
  int		there_is_a_selection ;
  int		left_positionned ;
  int		right_positionned ;
};

struct		_WaveditorClass
{
  GtkVBoxClass	parent_class;

  void		(* waveditor) (Waveditor *wve);
};

guint          waveditor_get_type        (void);
GtkWidget*     waveditor_new             (void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __TICTACTOE_H__ */












